﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace CellStrikethrough_Silverlight_CSharp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            List<Product> list = new List<Product>();
            list.Add(new Product() { Code = "A10001", Name = "ComponentOne Studio for Silverlight", Quantity = 10 });
            list.Add(new Product() { Code = "A10002", Name = "ComponentOne Studio for WPF", Quantity = 20 });
            list.Add(new Product() { Code = "A10003", Name = "Spread Studio for .NET 表格控件软件 V7.0", Quantity = 30 });
            list.Add(new Product() { Code = "A10004", Name = "Spread for ASP.NET 表格控件软件 V7.0", Quantity = 40 });
            list.Add(new Product() { Code = "A10005", Name = "Spread for Winforms 表格控件软件 V7.0", Quantity = 30 });
            list.Add(new Product() { Code = "A10006", Name = "ActiveReports 报表控件软件 V7.0 专业版", Quantity = 25 });
            list.Add(new Product() { Code = "A10007", Name = "ActiveReports 报表控件软件 V7.0 标准版", Quantity = 20 });

            this.c1Flexgrid1.ItemsSource = list;
            this.c1Flexgrid1.Columns[0].Header = "编号";
            this.c1Flexgrid1.Columns[1].Header = "名称";
            this.c1Flexgrid1.Columns[2].Header = "单价";
            this.c1Flexgrid1.CellFactory = new StrikeoutCellFactory();
        }
    }

    public class StrikeoutCellFactory : C1.Silverlight.FlexGrid.CellFactory
    {
        public override void CreateCellContent(C1.Silverlight.FlexGrid.C1FlexGrid grid, System.Windows.Controls.Border bdr, C1.Silverlight.FlexGrid.CellRange rng)
        {
            base.CreateCellContent(grid, bdr, rng);

            if (rng.Column == 0)
            {
                var obj = bdr.Child;
                if (obj.GetType().Equals(typeof(TextBlock)))
                {
                    if (!(((TextBlock)obj).Text == string.Empty))
                    {
                        bdr.Child = null;
                        double width = 0;
                        double height = 0;
                        if ((TextBlock)obj != null)
                        {
                            width = ((TextBlock)obj).ActualWidth ;
                            height = ((TextBlock)obj).ActualHeight;
                        }
                        Line ln = new Line();
                        ln.Stroke = new SolidColorBrush(Colors.Red);
                        ln.StrokeThickness = 1;
                        ln.X1 = 0;
                        ln.Y1 = (height / 2) + 3;
                        ln.X2 = width + 1;
                        ln.Y2 = (height / 2) + 3;
                        Grid grd = new Grid();
                        grd.Children.Add(ln);
                        grd.Children.Add(obj);
                        ((TextBlock)obj).Foreground = new SolidColorBrush(Colors.Green);
                        bdr.Child = grd;
                    }
                }
            }

        }
    }

    public class Product
    {
        public string Code
        {
            get;
            set;
        }

        public string Name
        {
            get;
            set;
        }
        
        public int Quantity
        {
            get;
            set;
        }
    }
}
